package com.sencha.gxt.core.client.dom;

import com.google.gwt.user.client.ui.UIObject;

public interface ScrollSupport {

  /**
   * Scroll enumeration.
   */
  public enum ScrollMode {
    AUTO("auto"), AUTOX("auto"), AUTOY("auto"), ALWAYS("scroll"), NONE("hidden");
    private final String value;

    private ScrollMode(String value) {
      this.value = value;
    }

    public String value() {
      return value;
    }
  }
  
  public void setScrollMode(ScrollMode scroll);
  
  public ScrollMode getScrollMode();

  public void ensureVisible(UIObject item);

  public int getHorizontalScrollPosition();

  public int getMaximumHorizontalScrollPosition();

  public int getMaximumVerticalScrollPosition();

  public int getMinimumHorizontalScrollPosition();

  public int getMinimumVerticalScrollPosition();

  public int getVerticalScrollPosition();

  public void scrollToBottom();

  public void scrollToLeft();

  public void scrollToRight();

  public void scrollToTop();

  public void setHorizontalScrollPosition(int position);

  public void setVerticalScrollPosition(int position);

}
