package com.sencha.gxt.theme.base.client.progress;

import com.google.gwt.resources.client.CssResource;
import com.google.gwt.resources.client.ImageResource;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.cell.core.client.ProgressBarCell.ProgressBarAppearance;
import com.sencha.gxt.core.client.XTemplates;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.core.client.util.Util;

public class ProgressBarDefaultAppearance implements ProgressBarAppearance {

  public interface ProgressBarTemplate extends XTemplates {
    // Value is boxed type
    // http://code.google.com/p/google-web-toolkit/issues/detail?id=6591
    @XTemplate(source = "ProgressBar.html")
    SafeHtml render(ProgressBarStyle style, Double value, int width);
  }
  public interface ProgressBarResources {

    ImageResource bar();

    ProgressBarStyle style();
  }

  public interface ProgressBarStyle extends CssResource {

    String progressBar();

    String progressInner();

    String progressText();

    String progressTextBack();

    String progressWrap();

  }

  private ProgressBarStyle style;
  private ProgressBarTemplate template;


  public ProgressBarDefaultAppearance(ProgressBarResources resources, ProgressBarTemplate template) {
    this.style = resources.style();
    this.style.ensureInjected();
    this.template = template;
  }

  @Override
  public void render(SafeHtmlBuilder sb, Double value, int width) {
    value = value == null ? 0 : value;

    sb.append(template.render(style, value * width, width));
  }

  @Override
  public void updateText(XElement parent, String text) {
    getTopElem(parent).getFirstChildElement().setInnerHTML(Util.isEmptyString(text) ? "&#160;" : text);
    getBackElem(parent).getFirstChildElement().setInnerHTML(Util.isEmptyString(text) ? "&#160;" : text);
  }

  protected XElement getBackElem(XElement parent) {
    return parent.selectNode("." + style.progressTextBack());
  }

  protected XElement getTopElem(XElement parent) {
    return parent.selectNode("." + style.progressText());
  }

}