package com.sencha.gxt.widget.core.client.form;

import com.google.gwt.editor.client.CompositeEditor;
import com.google.gwt.editor.client.Editor;
import com.google.gwt.editor.client.EditorDelegate;
import com.google.gwt.editor.client.LeafValueEditor;
import com.sencha.gxt.data.shared.Converter;

public class ConverterEditorAdapter<T, U, E extends Editor<U>> implements CompositeEditor<T, U, E>, LeafValueEditor<T> {

  private EditorChain<U, E> chain;
  private T value;
  private final E editor;
  private final Converter<T, U> converter;

  public ConverterEditorAdapter(E editor, Converter<T, U> converter) {
    this.editor = editor;
    this.converter = converter;
  }

  @Override
  public void flush() {
    value = converter.convertFieldValue(chain.getValue(editor));
  }

  @Override
  public void onPropertyChange(String... paths) {
  }

  @Override
  public void setDelegate(EditorDelegate<T> delegate) {
  }

  @Override
  public void setValue(T value) {
    chain.attach(converter.convertModelValue(value), editor);
  }

  @Override
  public T getValue() {
    return value;
  }


  @Override
  public E createEditorForTraversal() {
    return editor;
  }

  @Override
  public String getPathElement(E subEditor) {
    return "";
  }

  @Override
  public void setEditorChain(CompositeEditor.EditorChain<U, E> chain) {
    this.chain = chain;
  }

}
